Index: /BAORadio/libindi/libindi/libs/indibase/basedriver.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/basedriver.cpp	(revision 503)
+++ /BAORadio/libindi/libindi/libs/indibase/basedriver.cpp	(revision 504)
@@ -13,4 +13,10 @@
     mediator = NULL;
     lp = newLilXML();
+
+    if (getenv("INDIDEV") != NULL)
+    {
+        strncpy(deviceID, getenv("INDIDEV"), MAXINDINAME);
+        putenv("INDIDEV=");
+    }
 }
 
@@ -18,90 +24,55 @@
 INDI::BaseDriver::~BaseDriver()
 {
-    std::vector<INumberVectorProperty *>::const_iterator numi;
-    std::vector<ISwitchVectorProperty *>::const_iterator switchi;
-    std::vector<ITextVectorProperty *>::const_iterator texti;
-    std::vector<ILightVectorProperty *>::const_iterator lighti;
-    std::vector<IBLOBVectorProperty *>::const_iterator blobi;
-
     delLilXML (lp);
-    pAll.clear();
-
-    for ( numi = pNumbers.begin(); numi != pNumbers.end(); numi++)
-        delete (*numi);
-
-   for ( switchi = pSwitches.begin(); switchi != pSwitches.end(); switchi++)
-        delete (*switchi);
-
-   for ( texti = pTexts.begin(); texti != pTexts.end(); texti++)
-        delete (*texti);
-
-   for ( lighti = pLights.begin(); lighti != pLights.end(); lighti++)
-        delete (*lighti);
-
-   for ( blobi = pBlobs.begin(); blobi != pBlobs.end(); blobi++)
-        delete (*blobi);
 }
 
 INumberVectorProperty * INDI::BaseDriver::getNumber(const char *name)
 {
-    std::vector<INumberVectorProperty *>::const_iterator numi;
-
-    for ( numi = pNumbers.begin(); numi != pNumbers.end(); numi++)
-        if (!strcmp(name, (*numi)->name))
-            return *numi;
-
-    return NULL;
-
+    INumberVectorProperty * nvp = NULL;
+
+    nvp = static_cast<INumberVectorProperty *> (getProperty(name, INDI_NUMBER));
+
+    return nvp;
 }
 
 ITextVectorProperty * INDI::BaseDriver::getText(const char *name)
 {
-    std::vector<ITextVectorProperty *>::const_iterator texti;
-
-    for ( texti = pTexts.begin(); texti != pTexts.end(); texti++)
-        if (!strcmp(name, (*texti)->name))
-            return *texti;
-
-    return NULL;
+    ITextVectorProperty * tvp = NULL;
+
+    tvp = static_cast<ITextVectorProperty *> (getProperty(name, INDI_TEXT));
+
+    return tvp;
 }
 
 ISwitchVectorProperty * INDI::BaseDriver::getSwitch(const char *name)
 {
-    std::vector<ISwitchVectorProperty *>::const_iterator switchi;
-
-    for ( switchi = pSwitches.begin(); switchi != pSwitches.end(); switchi++)
-        if (!strcmp(name, (*switchi)->name))
-            return *switchi;
-
-    return NULL;
-
+    ISwitchVectorProperty * svp = NULL;
+
+    svp = static_cast<ISwitchVectorProperty *> (getProperty(name, INDI_SWITCH));
+
+    return svp;
 }
 
 ILightVectorProperty * INDI::BaseDriver::getLight(const char *name)
 {
-    std::vector<ILightVectorProperty *>::const_iterator lighti;
-
-    for ( lighti = pLights.begin(); lighti != pLights.end(); lighti++)
-        if (!strcmp(name, (*lighti)->name))
-            return *lighti;
-
-    return NULL;
-
+    ILightVectorProperty * lvp = NULL;
+
+    lvp = static_cast<ILightVectorProperty *> (getProperty(name, INDI_LIGHT));
+
+    return lvp;
 }
 
 IBLOBVectorProperty * INDI::BaseDriver::getBLOB(const char *name)
-{
-    std::vector<IBLOBVectorProperty *>::const_iterator blobi;
-
-    for ( blobi = pBlobs.begin(); blobi != pBlobs.end(); blobi++)
-        if (!strcmp(name, (*blobi)->name))
-            return *blobi;
-
-    return NULL;
-}
-
-void * INDI::BaseDriver::getProperty(const char *name, INDI_TYPE & type)
-{
-    std::vector<pOrder>::const_iterator orderi;
+{       
+  IBLOBVectorProperty * bvp = NULL;
+
+  bvp = static_cast<IBLOBVectorProperty *> (getProperty(name, INDI_BLOB));
+
+  return bvp;
+}
+
+void * INDI::BaseDriver::getProperty(const char *name, INDI_TYPE type)
+{
+    std::map< boost::shared_ptr<void>, INDI_TYPE>::iterator orderi;
 
     INumberVectorProperty *nvp;
@@ -110,52 +81,39 @@
     ILightVectorProperty *lvp;
     IBLOBVectorProperty *bvp;
-    int i=0;
-
-    for (i=0, orderi = pAll.begin(); orderi != pAll.end(); orderi++, i++)
-    {
-        switch ( (*orderi).type)
+
+    for (orderi = pAll.begin(); orderi != pAll.end(); orderi++)
+    {
+        if (type != INDI_UNKNOWN &&  orderi->second != type)
+            continue;
+
+        switch (orderi->second)
         {
         case INDI_NUMBER:
-            nvp = static_cast<INumberVectorProperty *>((*orderi).p);
+            nvp = static_cast<INumberVectorProperty *>((orderi->first).get());
             if (!strcmp(name, nvp->name))
-            {
-                type = INDI_NUMBER;
-                return (*orderi).p;
-            }
-
+                return (orderi->first).get();
              break;
         case INDI_TEXT:
-             tvp = static_cast<ITextVectorProperty *>((*orderi).p);
+             tvp = static_cast<ITextVectorProperty *>((orderi->first).get());
              if (!strcmp(name, tvp->name))
-             {
-                 type = INDI_TEXT;
-                 return (*orderi).p;
-             }
+                return (orderi->first).get();
              break;
         case INDI_SWITCH:
-             svp = static_cast<ISwitchVectorProperty *>((*orderi).p);
+             svp = static_cast<ISwitchVectorProperty *>((orderi->first).get());
              if (!strcmp(name, svp->name))
-             {
-                 type = INDI_SWITCH;
-                 return (*orderi).p;
-             }
+                 return (orderi->first).get();
              break;
         case INDI_LIGHT:
-             lvp = static_cast<ILightVectorProperty *>((*orderi).p);
+             lvp = static_cast<ILightVectorProperty *>((orderi->first).get());
              if (!strcmp(name, lvp->name))
-             {
-                 type = INDI_LIGHT;
-                 return (*orderi).p;
-             }
+                 return (orderi->first).get();
              break;
         case INDI_BLOB:
-             bvp = static_cast<IBLOBVectorProperty *>((*orderi).p);
+             bvp = static_cast<IBLOBVectorProperty *>((orderi->first).get());
              if (!strcmp(name, bvp->name))
-             {
-                 type = INDI_BLOB;
-                 return (*orderi).p;
-             }
+                 return (orderi->first).get();
              break;
         }
+
     }
 
@@ -165,5 +123,5 @@
 int INDI::BaseDriver::removeProperty(const char *name)
 {
-    std::vector<pOrder>::iterator orderi;
+    std::map< boost::shared_ptr<void>, INDI_TYPE>::iterator orderi;
 
     INumberVectorProperty *nvp;
@@ -175,48 +133,43 @@
     for (orderi = pAll.begin(); orderi != pAll.end(); orderi++)
     {
-        switch ( (*orderi).type)
+        switch (orderi->second)
         {
         case INDI_NUMBER:
-            nvp = static_cast<INumberVectorProperty *>((*orderi).p);
+            nvp = static_cast<INumberVectorProperty *>((orderi->first).get());
             if (!strcmp(name, nvp->name))
             {
                  pAll.erase(orderi);
-                 delete (nvp);
                  return 0;
              }
              break;
         case INDI_TEXT:
-             tvp = static_cast<ITextVectorProperty *>((*orderi).p);
+             tvp = static_cast<ITextVectorProperty *>((orderi->first).get());
              if (!strcmp(name, tvp->name))
              {
                   pAll.erase(orderi);
-                  delete (tvp);
                   return 0;
               }
              break;
         case INDI_SWITCH:
-             svp = static_cast<ISwitchVectorProperty *>((*orderi).p);
+             svp = static_cast<ISwitchVectorProperty *>((orderi->first).get());
              if (!strcmp(name, svp->name))
              {
                   pAll.erase(orderi);
-                  delete (svp);
                   return 0;
               }
              break;
         case INDI_LIGHT:
-             lvp = static_cast<ILightVectorProperty *>((*orderi).p);
+             lvp = static_cast<ILightVectorProperty *>((orderi->first).get());
              if (!strcmp(name, lvp->name))
              {
                   pAll.erase(orderi);
-                  delete (lvp);
                   return 0;
               }
              break;
         case INDI_BLOB:
-             bvp = static_cast<IBLOBVectorProperty *>((*orderi).p);
+             bvp = static_cast<IBLOBVectorProperty *>((orderi->first).get());
              if (!strcmp(name, bvp->name))
              {
                   pAll.erase(orderi);
-                  delete (bvp);
                   return 0;
               }
@@ -255,8 +208,5 @@
             buildProp(root, errmsg);
 
-
-
     /**************************************************************************/
-
 }
 
@@ -268,5 +218,5 @@
     XMLEle *ep = NULL;
     char *rtag, *rname, *rdev;
-    INDI_TYPE type;
+    //INDI_TYPE type;
     double timeout=0;
 
@@ -277,5 +227,5 @@
         return -1;
 
-    if (!deviceID[0])
+   /* if (!deviceID[0])
     {
         if (getenv("INDIDEV"))
@@ -283,12 +233,16 @@
         else
             strncpy(deviceID, rdev, MAXINDINAME);
-    }
-
-    if (getProperty(rname, type) != NULL)
+    }*/
+
+    if (!deviceID[0])
+        strncpy(deviceID, rdev, MAXINDINAME);
+
+    //if (getProperty(rname, type) != NULL)
+    if (getProperty(rname) != NULL)
         return INDI::BaseClient::INDI_PROPERTY_DUPLICATED;
 
-    if (crackIPerm(findXMLAttValu(root, "perm"), &perm) < 0)
-    {
-        IDLog("Error extracting %s permission (%s)", rname, findXMLAttValu(root, "perm"));
+    if (strcmp (rtag, "defLightVector") && crackIPerm(findXMLAttValu(root, "perm"), &perm) < 0)
+    {
+        IDLog("Error extracting %s permission (%s)\n", rname, findXMLAttValu(root, "perm"));
         return -1;
     }
@@ -298,5 +252,5 @@
     if (crackIPState (findXMLAttValu(root, "state"), &state) < 0)
     {
-        IDLog("Error extracting %s state (%s)", rname, findXMLAttValu(root, "state"));
+        IDLog("Error extracting %s state (%s)\n", rname, findXMLAttValu(root, "state"));
         return -1;
     }
@@ -305,5 +259,7 @@
     {
 
-        INumberVectorProperty *nvp = new INumberVectorProperty;
+        numberPtr nvp(new INumberVectorProperty);
+        //INumberVectorProperty *nvp = new INumberVectorProperty;
+        //INumberVectorProperty *nvp = (INumberVectorProperty *) malloc(sizeof(INumberVectorProperty));
         INumber *np = NULL;
         int n=0;
@@ -325,5 +281,5 @@
             np = (INumber *) realloc(np, (n+1) * sizeof(INumber));
 
-            np[n].nvp = nvp;
+            np[n].nvp = nvp.get();
 
             XMLAtt *na = findXMLAtt (ep, "name");
@@ -364,8 +320,12 @@
         nvp->nnp = n;
         nvp->np  = np;
-        pNumbers.push_back(nvp);
-        pOrder o = { INDI_NUMBER, nvp };
-        pAll.push_back(o);
-        IDLog("Adding number property %s to list.\n", nvp->name);
+        //orderPtr o(new pOrder);
+        //o->p = &nvp;
+        //o->type = INDI_NUMBER;
+        //pAll.push_back(o);
+        pAll[nvp] = INDI_NUMBER;
+        //IDLog("Adding number property %s to list.\n", nvp->name);
+        if (mediator)
+            mediator->newProperty(nvp->device, nvp->name);
     }
     else
@@ -374,5 +334,7 @@
   else if (!strcmp (rtag, "defSwitchVector"))
         {
-            ISwitchVectorProperty *svp = new ISwitchVectorProperty;
+            switchPtr svp(new ISwitchVectorProperty);
+            //ISwitchVectorProperty *svp = new ISwitchVectorProperty;
+            //ISwitchVectorProperty *svp = (ISwitchVectorProperty *) malloc(sizeof(ISwitchVectorProperty));
             ISwitch *sp = NULL;
             int n=0;
@@ -398,5 +360,5 @@
                 sp = (ISwitch *) realloc(sp, (n+1) * sizeof(ISwitch));
 
-                sp[n].svp = svp;
+                sp[n].svp = svp.get();
 
                 XMLAtt *na = findXMLAtt (ep, "name");
@@ -418,8 +380,12 @@
             svp->nsp = n;
             svp->sp  = sp;
-            pSwitches.push_back(svp);
-            pOrder o = { INDI_SWITCH, svp };
-            pAll.push_back(o);
-            IDLog("Adding Switch property %s to list.\n", svp->name);
+            //orderPtr o(new pOrder);
+            //o->p = &svp;
+            //o->type = INDI_SWITCH;
+            //pAll.push_back(o);
+            pAll[svp] = INDI_SWITCH;
+            //IDLog("Adding Switch property %s to list.\n", svp->name);
+            if (mediator)
+                mediator->newProperty(svp->device, svp->name);
         }
         else
@@ -430,5 +396,7 @@
     {
 
-        ITextVectorProperty *tvp = new ITextVectorProperty;
+        //ITextVectorProperty *tvp = new ITextVectorProperty;
+        //ITextVectorProperty *tvp = (ITextVectorProperty *) malloc(sizeof(ITextVectorProperty));
+        textPtr tvp(new ITextVectorProperty);
         IText *tp = NULL;
         int n=0;
@@ -450,5 +418,5 @@
             tp = (IText *) realloc(tp, (n+1) * sizeof(IText));
 
-            tp[n].tvp = tvp;
+            tp[n].tvp = tvp.get();
 
             XMLAtt *na = findXMLAtt (ep, "name");
@@ -471,8 +439,12 @@
         tvp->ntp = n;
         tvp->tp  = tp;
-        pTexts.push_back(tvp);
-        pOrder o = { INDI_TEXT, tvp };
-        pAll.push_back(o);
-        IDLog("Adding Text property %s to list.\n", tvp->name);
+        //orderPtr o(new pOrder);
+        //o->p = &tvp;
+        //o->type = INDI_TEXT;
+        //pAll.push_back(o);
+        pAll[tvp] = INDI_TEXT;
+        //IDLog("Adding Text property %s to list.\n", tvp->name);
+        if (mediator)
+            mediator->newProperty(tvp->device, tvp->name);
     }
     else
@@ -482,5 +454,7 @@
     {
 
-        ILightVectorProperty *lvp = new ILightVectorProperty;
+        //ILightVectorProperty *lvp = new ILightVectorProperty;
+        //ILightVectorProperty *lvp = (ILightVectorProperty *) malloc(sizeof(ILightVectorProperty));
+        lightPtr lvp(new ILightVectorProperty);
         ILight *lp = NULL;
         int n=0;
@@ -500,5 +474,5 @@
             lp = (ILight *) realloc(lp, (n+1) * sizeof(ILight));
 
-            lp[n].lvp = lvp;
+            lp[n].lvp = lvp.get();
 
             XMLAtt *na = findXMLAtt (ep, "name");
@@ -521,8 +495,12 @@
         lvp->nlp = n;
         lvp->lp  = lp;
-        pLights.push_back(lvp);
-        pOrder o = { INDI_LIGHT, lvp };
-        pAll.push_back(o);
-        IDLog("Adding Light property %s to list.\n", lvp->name);
+        //orderPtr o(new pOrder);
+        //o->p = &lvp;
+        //o->type = INDI_LIGHT;
+        //pAll.push_back(o);
+        pAll[lvp] = INDI_LIGHT;
+        //IDLog("Adding Light property %s to list.\n", lvp->name);
+        if (mediator)
+            mediator->newProperty(lvp->device, lvp->name);
     }
     else
@@ -532,5 +510,7 @@
     {
 
-        IBLOBVectorProperty *bvp = new IBLOBVectorProperty;
+        //IBLOBVectorProperty *bvp = new IBLOBVectorProperty;
+        //IBLOBVectorProperty *bvp = (IBLOBVectorProperty *) malloc(sizeof(IBLOBVectorProperty));
+        blobPtr bvp(new IBLOBVectorProperty);
         IBLOB *bp = NULL;
         int n=0;
@@ -550,5 +530,5 @@
             bp = (IBLOB *) realloc(bp, (n+1) * sizeof(IBLOB));
 
-            bp[n].bvp = bvp;
+            bp[n].bvp = bvp.get();
 
             XMLAtt *na = findXMLAtt (ep, "name");
@@ -580,8 +560,12 @@
         bvp->nbp = n;
         bvp->bp  = bp;
-        pBlobs.push_back(bvp);
-        pOrder o = { INDI_BLOB, bvp };
-        pAll.push_back(o);
-        IDLog("Adding BLOB property %s to list.\n", bvp->name);
+        //orderPtr o(new pOrder);
+        //o->p = &bvp;
+        //o->type = INDI_BLOB;
+        //pAll.push_back(o);
+        pAll[bvp] = INDI_BLOB;
+        //IDLog("Adding BLOB property %s to list.\n", bvp->name);
+        if (mediator)
+            mediator->newProperty(bvp->device, bvp->name);
     }
     else
@@ -609,33 +593,4 @@
         return false;
 
-}
-
-void INDI::BaseDriver::setConnected(bool status)
-{
-    ISwitch *sp = NULL;
-    ISwitchVectorProperty *svp = getSwitch("CONNECTION");
-    if (!svp)
-        return;
-
-    IUResetSwitch(svp);
-
-    // Connect
-    if (status)
-    {
-        sp = IUFindSwitch(svp, "CONNECT");
-        if (!sp)
-            return;
-        sp->s = ISS_ON;
-    }
-    // Disconnect
-    else
-    {
-        sp = IUFindSwitch(svp, "DISCONNECT");
-        if (!sp)
-            return;
-        sp->s = ISS_ON;
-    }
-
-    svp->s = IPS_OK;
 }
 
@@ -958,2 +913,64 @@
 }
 
+void INDI::BaseDriver::registerProperty(void *p, INDI_TYPE type)
+{
+
+
+    if (type == INDI_NUMBER)
+    {
+        INumberVectorProperty *nvp = static_cast<INumberVectorProperty *> (p);
+        if (getProperty(nvp->name, INDI_NUMBER) != NULL)
+            return;
+
+        numberPtr ovp(nvp);
+
+        pAll[ovp] = INDI_NUMBER;
+    }
+    else if (type == INDI_TEXT)
+    {
+       ITextVectorProperty *tvp = static_cast<ITextVectorProperty *> (p);
+       if (getProperty(tvp->name, INDI_TEXT) != NULL)
+           return;
+
+       textPtr ovp(tvp);
+       //o->p = &ovp;
+
+       pAll[ovp] = INDI_TEXT;
+   }
+    else if (type == INDI_SWITCH)
+    {
+       ISwitchVectorProperty *svp = static_cast<ISwitchVectorProperty *> (p);
+       if (getProperty(svp->name, INDI_SWITCH) != NULL)
+           return;
+
+       switchPtr ovp(svp);
+       //o->p = &ovp;
+
+       IDLog("Registering switch %s\n", svp->name);
+
+       pAll[ovp] = INDI_SWITCH;
+    }
+    else if (type == INDI_LIGHT)
+    {
+       ILightVectorProperty *lvp = static_cast<ILightVectorProperty *> (p);
+       if (getProperty(lvp->name, INDI_LIGHT) != NULL)
+           return;
+
+       lightPtr ovp(lvp);
+       //o->p = &ovp;
+       pAll[ovp] = INDI_LIGHT;
+   }
+    else if (type == INDI_BLOB)
+    {
+       IBLOBVectorProperty *bvp = static_cast<IBLOBVectorProperty *> (p);
+       if (getProperty(bvp->name, INDI_BLOB) != NULL)
+           return;
+
+       blobPtr ovp(bvp);
+       //o->p = &ovp;
+
+       pAll[ovp] = INDI_BLOB;
+    }
+
+}
+
Index: /BAORadio/libindi/libindi/libs/indibase/basedriver.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/basedriver.h	(revision 503)
+++ /BAORadio/libindi/libindi/libs/indibase/basedriver.h	(revision 504)
@@ -2,5 +2,5 @@
 #define INDIBASEDRIVER_H
 
-#include <vector>
+#include <boost/shared_ptr.hpp>
 #include <map>
 #include <string>
@@ -26,5 +26,5 @@
 public:
     BaseDriver();
-    virtual ~BaseDriver();
+    ~BaseDriver();
 
     /*! INDI error codes. */
@@ -38,5 +38,5 @@
 
     /*! INDI property type */
-    enum INDI_TYPE
+    typedef enum
     {
         INDI_NUMBER, /*!< INumberVectorProperty. */
@@ -44,6 +44,7 @@
         INDI_TEXT,   /*!< ITextVectorProperty. */
         INDI_LIGHT,  /*!< ILightVectorProperty. */
-        INDI_BLOB    /*!< IBLOBVectorProperty. */
-    };
+        INDI_BLOB,    /*!< IBLOBVectorProperty. */
+        INDI_UNKNOWN
+    } INDI_TYPE;
 
     /** \return Return vector number property given its name */
@@ -57,4 +58,6 @@
     /** \return Return vector BLOB property given its name */
     IBLOBVectorProperty * getBLOB(const char *name);
+
+    void registerProperty(void *p, INDI_TYPE type);
 
     /** \brief Remove a property
@@ -74,5 +77,5 @@
 
     */
-    void * getProperty(const char *name, INDI_TYPE & type);
+    void * getProperty(const char *name, INDI_TYPE type = INDI_UNKNOWN);
 
     /** \brief Build driver properties from a skeleton file.
@@ -90,9 +93,5 @@
     /** \return True if the device is connected (CONNECT=ON), False otherwise */
     bool isConnected();
-    /** \brief Connect or Disconnect a device.
-      \param status If true, the driver will attempt to connect to the device (CONNECT=ON). If false, it will attempt
-to disconnect the device.
-    */
-    virtual void setConnected(bool status);
+
 
     /** \brief Set the device name
@@ -100,4 +99,5 @@
       */
     void setDeviceName(const char *dev);
+
     /** \return Returns the device name */
     const char *deviceName();
@@ -107,11 +107,14 @@
     */
     void addMessage(const char *msg);
-    //** \returns Returns the contents of the driver's message queue. *;
+
+    /** \return Returns the contents of the driver's message queue. */
     const char *message() { return messageQueue.c_str(); }
 
     /** \brief Set the driver's mediator to receive notification of news devices and updated property values. */
     void setMediator(INDI::BaseMediator *med) { mediator = med; }
+
     /** \returns Get the meditator assigned to this driver */
     INDI::BaseMediator * getMediator() { return mediator; }
+
 
 protected:
@@ -120,5 +123,4 @@
       \param root XML element to parse and build.
       \param errmsg buffer to store error message in parsing fails.
-
       \return 0 if parsing is successful, -1 otherwise and errmsg is set */
     int buildProp(XMLEle *root, char *errmsg);
@@ -133,21 +135,15 @@
     char deviceID[MAXINDINAME];
 
+    typedef boost::shared_ptr<INumberVectorProperty> numberPtr;
+    typedef boost::shared_ptr<ITextVectorProperty> textPtr;
+    typedef boost::shared_ptr<ISwitchVectorProperty> switchPtr;
+    typedef boost::shared_ptr<ILightVectorProperty> lightPtr;
+    typedef boost::shared_ptr<IBLOBVectorProperty> blobPtr;
+
 private:
 
-    typedef struct
-    {
-        INDI_TYPE type;
-        void *p;
-    } pOrder;
-
-    std::vector<INumberVectorProperty *> pNumbers;
-    std::vector<ITextVectorProperty *> pTexts;
-    std::vector<ISwitchVectorProperty *> pSwitches;
-    std::vector<ILightVectorProperty *> pLights;
-    std::vector<IBLOBVectorProperty *> pBlobs;
+    std::map< boost::shared_ptr<void>, INDI_TYPE> pAll;
 
     LilXML *lp;
-
-    std::vector<pOrder> pAll;
 
     std::string messageQueue;
